#!/usr/bin/env ruby

require "./params_reader.rb"

def generate_indexes_arr(new_entry, indexes_arr, sizes_arr, curr_sub_arr)
	if(curr_sub_arr == sizes_arr.length-1)
		(0...sizes_arr[curr_sub_arr]).each do |ind|
			indexes_arr<<new_entry+ind.to_s
		end
	else	
		(0...sizes_arr[curr_sub_arr]).each do |ind|
			generate_indexes_arr(new_entry+ind.to_s, indexes_arr, sizes_arr, curr_sub_arr + 1)
		end
	end
	return indexes_arr
end
#sizes_arr = [3,3,2]
#curr_sub_arr = 0
#empty_oligo = ""
#indexes_arr = []
#res = generate_indexes_arr(empty_oligo, indexes_arr, sizes_arr, curr_sub_arr)
#print res.join("\n")	


def construct_dataset_run_command_arr(params_arr)

	if(params_arr == [])
		return [{}]
	end

	sizes_arr = []
	params_arr.each do |elem|
		val = elem[1]
		sizes_arr.push(val.length)
	end
#	print "params_arr: #{params_arr.inspect}\n"
#	print "sizes_arr: #{sizes_arr.inspect}\n"
#	$stdin.gets

	curr_sub_arr = 0
	empty_oligo = ""
	empty_arr = []
	indexes_arr = generate_indexes_arr(empty_oligo, empty_arr, sizes_arr, curr_sub_arr)
#	print "indexes_arr:\n#{indexes_arr.join("\n")}\n"	
#	$stdin.gets

	dataset_run_command_arr = []
	indexes_arr.each do |indexes|
		key_ind = 0
		curr_args_hash = {}
		indexes.split("").collect {|e| e.to_i}.each do |val_ind|
			key = params_arr[key_ind][0]
			val = params_arr[key_ind][1][val_ind].strip
			curr_args_hash[key]=val
			key_ind+=1
		end
#		print "curr_args_hash:\n#{curr_args_hash.inspect}\n"	
#		$stdin.gets
		dataset_run_command_arr.push(curr_args_hash)
	end

#	print "done:\n#{dataset_run_command_arr.inspect}\n"	
#	$stdin.gets

	return dataset_run_command_arr
end


def parse_run_file_template(run_file_template)
	params = {}
	IO.readlines(run_file_template).each do |line|
		if(line.scan(/^#/) != [])
			next
		end
		arr=line.split("=")
		if(arr.length > 1)
			key=arr[0]
			val=arr[1].strip
			if(val.scan("[") != [])
				if(val.scan("]") != [])		
					params[key]=[]
					val.split("[")[1].split("]")[0].split(",").each do |v|
						params[key].push(v)
					end
				else
					print "ERROR: 'parse_run_file_template': USAGE: pam_key=[pama_val_1, params_val_2,...,param_val_K]\n"
					exit
				end
			end
		end
	end
	return params.to_a
end


def extract_TF_names(evidence_files_dir)
	tf_cond = []
	if(FileTest.exist?(evidence_files_dir) == false)
		print "Error 'run_all.rb' (function: extract_TF_names). Directory #{evidence_files_dir} does not exist!\n"
		exit 
	end
	Dir.entries(evidence_files_dir).each do |file|
		if(file.scan("evidence_") != [] and File.stat("#{evidence_files_dir}/#{file}").directory?() == false)
			tf_cond.push(file.split("evidence_")[1].strip)
		end
	end
	return tf_cond 
end

def create_run_file(params, run_file_template, run_file_name)
	run_file_contents = ""
	loc_params = {}
	IO.readlines(run_file_template).each do |line|
		arr=line.split("=")
		key=arr[0].strip
		val=arr[1]
		if(params.keys.include?(key) == true)
			replacement="#{key}=#{params[key]}\n"
			loc_params[key]=params[key]
			run_file_contents<<replacement
		else
			if(val != nil)
				val=val.strip
				loc_params[key]=val.split("\s")[0]
			end
			run_file_contents<<line
		end
	end

	f_out = File.open(run_file_name, "w")
	f_out.write(run_file_contents)
	f_out.close()
	system("chmod u+rwx #{run_file_name}")
end


def post_process_results(tmp_suffix, results_dir, run_file_template)

	time_stamp="#{Time.now.to_s.split("\s").join("_")}"
	results_tmp_dir = "temp_results_#{time_stamp}"
	if(FileTest.exist?("#{results_tmp_dir}") == false)
		system("mkdir --parents #{results_tmp_dir}")
	end
	system("cp -r *#{tmp_suffix} #{results_tmp_dir}")
	system("rm -r *#{tmp_suffix}")
	Dir.entries("#{results_tmp_dir}").each do |tmp_file|
		if(tmp_file.scan(tmp_suffix) != [] and File.stat("#{results_tmp_dir}/#{tmp_file}").directory? == true)
			perm_file_name = "#{tmp_file.split("#{tmp_suffix}")[0]}#{time_stamp}"
			File.rename("#{results_tmp_dir}/#{tmp_file}", "#{results_tmp_dir}/#{perm_file_name}")
#			system("rm #{results_tmp_dir}/#{perm_file_name}/*.pdf")
#			system("rm #{results_tmp_dir}/#{perm_file_name}/*pssm")
		end
	end
	if(FileTest.exist?(results_dir) == false)
		system("mv #{results_tmp_dir} #{results_dir}")
	else
		system("cp -r #{results_tmp_dir}/* #{results_dir}")
		system("rm -r #{results_tmp_dir}")
	end
end


def add_entry_to_defaults_hash(defaults, io_params, entry)
	key=entry[0]
	default_value=entry[1]
	defaults[key] = default_value
	if(io_params[key] != nil)
		defaults[key] = io_params[key]
	end
end

def get_file_list_files_default_vals(io_params, input_root_dir)
	defaults = {}
	[
		["subdir_evidence", "#{input_root_dir}/evidence_file_list"],
		["subdir_seq", "#{input_root_dir}/seq_file_list"],
		["subdir_cov", "#{input_root_dir}/cov_file_list"],
		["path_pssm_files","#{input_root_dir}/pssms"]
	].each do |e|
		add_entry_to_defaults_hash(defaults, io_params, e)
	end

	defaults["path_evidence_files"] = "#{input_root_dir}/data/evidence"
	if(io_params["evidence_cERMIT_format_dir"] != nil)
		defaults["path_evidence_files"] = "#{input_root_dir}/#{io_params["evidence_cERMIT_format_dir"]}"
	end
	defaults["path_seq_files"] = "#{input_root_dir}/data/seq"
	if(io_params["seq_cERMIT_format_dir"] != nil)
		defaults["path_seq_files"] = "#{input_root_dir}/#{io_params["seq_cERMIT_format_dir"]}"
	end
	defaults["path_covariates_files"] = "#{input_root_dir}/covariates"
	if(io_params["covariates_root_dir"] != nil)
		defaults["path_covariates_files"] = "#{input_root_dir}/#{io_params["covariates_root_dir"]}"
	end
	defaults["covariates_to_use"] = "MM1"
	if(io_params["covariates_to_use"] != nil)
		defaults["covariates_type"] = io_params["covariates_to_use"]
	end
	return defaults
end

def extract_io_params(pars)
	if(pars["io_params_file"] == nil)
		pars["io_params_file"] = "params/io.params"
	end
	io_params = ParamsReader.read_params_file(pars["io_params_file"])
	if(io_params["run_file_template"] == nil)
		io_params["run_file_template"]="run_cERMIT_executable_template"
	end
	return io_params
end

def run(pars)

	io_params = extract_io_params(pars)

	# root directory for all input files
	input_root_dir="input"
	if(io_params["input_root_dir"] != nil)
		input_root_dir = io_params["input_root_dir"]
	end

	wd = Dir.getwd
	print "wd=#{wd}\n"

	run_file_template = io_params["run_file_template"]
	file_list_files_default = get_file_list_files_default_vals(io_params, input_root_dir)

	tf_cond=[]
	evidence_files_dir = "#{file_list_files_default["path_evidence_files"]}"
	tf_cond  = extract_TF_names(evidence_files_dir)

	params_key_vals_arr = parse_run_file_template(run_file_template)
#	print "params_key_vals_arr: #{params_key_vals_arr.inspect}\n"
#	$stdin.gets
	dataset_run_command_arr = construct_dataset_run_command_arr(params_key_vals_arr)

	dataset_run_command_arr.each do |params|
		out_dir=""
		delim=":"
		params.each do |k, v|
			out_dir<<"#{k}=#{v}#{delim}"
		end
		params_used="#{out_dir.split(delim).join(delim)}"
		if(params_used == "")
			params["out_dir"] = "out_#{io_params["tmp_suffix"]}"
		else
			params["out_dir"] = "out_#{params_used}_#{io_params["tmp_suffix"]}"
		end
		system("mkdir --parents #{params["out_dir"]}")

		params["cov_file_list_subdir"]="#{input_root_dir}/#{file_list_files_default["subdir_cov"]}"
		params["evidence_file_list_subdir"]="#{input_root_dir}/#{file_list_files_default["subdir_evidence"]}"
		params["seq_file_list_subdir"]="#{input_root_dir}/#{file_list_files_default["subdir_seq"]}"
		params["tmp_suff"]=io_params["tmp_suffix"]
		params["strand_specific_analysis"]=io_params["strand_specific_analysis"]

		num_to_run = tf_cond.length
		run_file_name=""
		tf_cond[0...num_to_run].each do |cond|
			time_stamp=Time.now.to_f.to_s
			params["tf_cond"]=cond
			run_file_name = "#{run_file_template}_#{cond}_#{time_stamp}"
			create_run_file(params, run_file_template, run_file_name)
			system("./#{run_file_name}")
		end
		system("cp #{run_file_name} #{params["out_dir"]}/#{run_file_template}")
		system("rm #{run_file_template}_*")
	end
	
	results_sub_dir = io_params["result_dir"]
	if(results_sub_dir == nil)
		results_sub_dir="results"
	end
	post_process_results(io_params["tmp_suffix"], results_sub_dir, run_file_template)
end


def parse_ARGV()
  pars = {}
  ARGV.each do |a|
    pars[a.split("=")[0]] = a.split("=")[1]
  end
  return pars
end
pars = parse_ARGV()

########
# RUN
########
run(pars)
########
# RUN
########

